//
// CSsu Speek interface
//
//

#include "csdriver.h"
#define ISEUC(x) (x >= 161 && x <= 254)
#define ISSS2(x) (x == 142)
#include <syslog.h>
#include <stdarg.h>
#include <stdio.h>

      

CSDriver::CSDriver()
{
  speak = 0;
  lang = 0;
}

CSDriver::~CSDriver()
{
  if (lang)
  {
    lang->close();
    delete lang;
  }
  if (speak)
  {
    speak->close();
    delete speak;
  }
}

void CSDriver::open(const char * lang_dic, const char * pcm_dic,  const char * pcm_device, int speed)
{
  speak = new CSPCM;
  lang = new CSLang;
  lang->open(lang_dic);
  speak->open(pcm_dic, pcm_device, speed);
}

void CSDriver::say(const char *msg)
{
  lang->exec(msg);
  char * p = lang->getResult();
  speak->say(p, strlen(p));
  lang->freeResult();
}

extern FILE * pcm_log_file;

void CSDriver::sayEuc(const char *msg, int len)
{
  if (msg && len)
  {
    char * sjis = new char[len+2];
    * sjis = ' ';
    eucToSjis((UInt8 *) msg, len, (UInt8 *) sjis+1);
    if (lang->exec(sjis))
    {
      char * p = lang->getResult();
      if (p)
      {
	len = strlen(p);
	if (len)
	{
	  speak->say(p, len);
	}
	lang->freeResult();
      }
    }
    delete sjis;
  }
}

void
CSDriver::eucToSjis(UInt8 * s, int len, UInt8 * o)
{
  UInt8 i1, i2;
  UInt8 o1, o2;
  while (len>0)
  {
    i1 = *s++;
    len--;
    if (ISEUC(i1))
    {
      i2 = *s++;
      len--;
      if (i1 & 1)
      {
	if (i1 < 0xdf)
	{
	  o1 = i1 / 2 + 0x31;
	}
	else
	{
	  o1 = i1 / 2 + 0x71;
	}
	if (i2 >= 0xe0)
	{
	  o2 = i2 - 0x60;
	}
	else
	{
	  o2 = i2 - 0x61;
	}
      }
      else
      {
	if (i1 < 0xdf)
	{
	  o1 = i1 / 2 + 0x30;
	}
	else
	{
	  o1 = i1 / 2 + 0x70;
	}
	o2 = i2 - 2;
      }
      *o++ = o1;
      *o++ = o2;
    }
    else if (ISSS2(i1))
    {
      *o++ = *s++;
      len--;
    }
    else
    {
      *o++ = i1;
    }
  }
  *o = '\0';
}

#if 0
main()
{
  CSDriver driver;
  driver.open();
  driver.say("test");
}
#endif


