#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <unistd.h>
#include <fcntl.h>
#include <termios.h>
#include <stdio.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/soundcard.h>
#include <fcntl.h>

#define  DSP_OUT   "/dev/dsp"

#define DSP_OPEN_ERROR 1
#define DSP_IOCTRL_ERROR 2

#include "driverpcm.h"   // sound device driver

DriverPCM::DriverPCM()
{
  sound_card = 0;
}

bool DriverPCM::open(const char * pcm_device)
{
  if ((sound_card = ::open(pcm_device, O_WRONLY)) < 0)
  {
    return false;
  }
  /* set STREO */
  parm = 1;           //0 is mono. 1 is streo.
  status = ioctl(sound_card , SNDCTL_DSP_STEREO, &parm);
  if (status < 0)
  {
    ::close(sound_card);
    sound_card = 0;
    return false;
  }
  parm = 2;
  status = ::ioctl(sound_card , SOUND_PCM_WRITE_CHANNELS, &parm);
 
  /*set 16bit sampling  */
  int arg = 16;      /* sample size */
  status = ::ioctl(sound_card, SOUND_PCM_WRITE_BITS, &arg);
  if (status < 0)
  {
    ::close(sound_card);
    sound_card = 0;
    return false;
  }

  sampling = 48000;
  status = ::ioctl(sound_card , SOUND_PCM_WRITE_RATE, &sampling);
  if (status < 0)
  {
    sampling = 44100;
    status = ::ioctl(sound_card , SOUND_PCM_WRITE_RATE, &sampling);
    {
      ::close(sound_card);
      sound_card = 0;
      return false;
    }
  }
  return true;
}

void DriverPCM::close()
{
  ::close(sound_card);
}

bool DriverPCM::send(char * p, int len) // len = word count (2byte)
{
  int slen = len * 2* 2*3; // 2byte * 2(streo) * 3times ( 48K / 16K = 3 )
  char * p2 = (char *) malloc(slen);
  int c = len;
  short int *src = (short int*) p;
  short int *dst = (short int*) p2;
  while (c--)
  {
    *dst++ = *src; //1
    *dst++ = *src; //2
    *dst++ = *src; //3
    *dst++ = *src; //4
    *dst++ = *src; //5
    *dst++ = *src++; //6
  }
  if (::write(sound_card, p2, slen) != slen)
  {
    free(p2);
    return false;
  }
  free(p2);
  return true;
}

bool DriverPCM::stop()
{
  status = ::ioctl(sound_card , SOUND_PCM_RESET, 0);
  if (status < 0)
  {
    ::close(sound_card);
    sound_card = 0;
    return false;
  }
  return true;
}

DriverPCM::~DriverPCM()
{
  if (sound_card)
  {
    ::close(sound_card);
  }
}
