//
// Fujisu Speek interface
//
//
#include "fujilang.h"   // fujisu lang
#include "fujipcm.h"    // sujisu pcm make
#include <string.h>

class FujiDriver {
  FujiPCM *speak;
  FujiLang *lang;
 public:
  FujiDriver();
  ~FujiDriver();
  void open();
  void say(char *msg);
};

FujiDriver::FujiDriver()
{
  speak = 0;
  lang = 0;
}

FujiDriver::~FujiDriver()
{
  if (lang)
  {
    lang->close();
    delete lang;
  }
  if (speak)
  {
    speak->close();
    delete speak;
  }
}

void FujiDriver::open()
{
  speak = new FujiPCM;
  lang = new FujiLang;
  lang->open("/usr/local/synth/dic/wd2k03.dic");
  speak->open("/usr/local/synth/dic/HIGH16.VSD");
}

void FujiDriver::say(char *msg)
{
  lang->exec(msg);
  char * p = lang->getResult();
  speak->say(p, strlen(p));
  lang->freeResult();
}


main()
{
  FujiDriver driver;
  driver.open();
  driver.say("test");
}
