/* $Id: braille.h,v 1.1.1.1 2004/05/09 03:04:06 tkudou Exp $ */
/*
 * BRLTTY - A background process providing access to the Linux console (when in
 *          text mode) for a blind person using a refreshable braille display.
 *
 * Copyright (C) 1995-2003 by The BRLTTY Team. All rights reserved.
 *
 * BRLTTY comes with ABSOLUTELY NO WARRANTY.
 *
 * This is free software, placed under the terms of the
 * GNU General Public License, as published by the Free Software
 * Foundation.  Please see the file COPYING for details.
 *
 * Web Page: http://mielke.cc/brltty/
 *
 * This software is maintained by Cypac Corporation <www.cypac.co.jp>.
 */

/* KGS/braille.h - Configurable definitions for the KGS driver
 * Copyright (C) 2004 by CYPAC Co., Inc. <www.cypac.co.jp>
 */

/* Known Device Identification Numbers (not to be changed) */
/* See OC_QUERY_EQUIPMENT in http://www.kgs-jpn.co.jp/dev/protocol.html */
#define KGS_AUTO	-1
/**/
#define KGS_BM16	0x01
#define KGS_BN46X	0x02
/*#define KGS_BN20A*/		/* undefined in protocol */
/*#define KGS_BN40A*/		/* undefined in protocol */
/*#define KGS_BN46C*/		/* undefined in protocol */
/*#define KGS_BN46D*/		/* undefined in protocol */


/***** User Settings *****  Edit as necessary for your system. */


/* Define next line to 1 if you have a firmware older than version 010495 */
/*#define ABT3_OLD_FIRMWARE 0*/


/* Specify the terminal model that you'll be using.
 * Use one of the previously defined device ID.
 * WARNING: Do not use BRL_AUTO if you have ABT3_OLD_FIRMWARE defined to 1 !
 */
#define MODEL   KGS_AUTO


#define KGS_DEFAULT_BAUDRATE B9600


/* typematic settings */
#define TYPEMATIC_DELAY 10	/* nbr of cycles before a key is repeated */
#define TYPEMATIC_REPEAT 2	/* nbr of cycles between each key repeat */


/* Delay in miliseconds between forced full refresh of the display.
 * This is to minimize garbage effects due to noise on the serial line.
 */
#define REFRESH_RATE 1000
