/* $Id: ipcifsrv.c,v 1.1.1.1 2004/05/09 03:04:07 tkudou Exp $ */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif /* HAVE_CONFIG_H */

#include <string.h>
#include <stdlib.h>

#ifdef WITH_IPCIF

#include "ipcif.h"
#include "ipcifcmd.h"

static char* ipcif_voice_string = 0;
static char* ipcif_detail_voice_string = 0;

char*
getIcpifVoiceString(void)
{
  return ipcif_voice_string;
}

char*
getIcpifDetailVoiceString(void)
{
  return ipcif_detail_voice_string;
}

void
setIpcifVoiceString(char* s, int length)
{
  if (ipcif_voice_string)
  {
    free((void*)ipcif_voice_string);
  }
  ipcif_voice_string = (char*)malloc(length);
  if (ipcif_voice_string)
  {
    memcpy(ipcif_voice_string, s, length);
  }
}

void
setIpcifDetailVoiceString(char* s, int length)
{
  if (ipcif_detail_voice_string)
  {
    free((void*)ipcif_detail_voice_string);
  }
  ipcif_detail_voice_string = (char*)malloc(length);
  if (ipcif_detail_voice_string)
  {
    memcpy(ipcif_detail_voice_string, s, length);
  }
}

void
deleteIpcifVoiceString()
{
  if (ipcif_voice_string)
  {
    free((void*)ipcif_voice_string);
    ipcif_voice_string = 0;
  }
}

void
deleteIpcifDetailVoiceString()
{
  if (ipcif_detail_voice_string)
  {
    free((void*)ipcif_detail_voice_string);
    ipcif_detail_voice_string = 0;
  }
}

int
getIpcifCmd()
{
  IPCIF_Msg* msg;
  msg = ipcif_readMsg();
  if (msg)
  {
    int valid_cmd = 1;
    long cmd_no;
    cmd_no = msg->cmd_no;
    switch (cmd_no)
    {
     case IPCIF_CMD_VOICE:
      if (msg->cmd_data[0] != '\0' && msg->cmd_data_length > 1)
      {
	setIpcifVoiceString(msg->cmd_data, msg->cmd_data_length);
      }
      else
      {
	valid_cmd = 0;
      }
      break;
     case IPCIF_CMD_DETAIL_VOICE:
      if (msg->cmd_data[0] != '\0' && msg->cmd_data_length > 1)
      {
	setIpcifDetailVoiceString(msg->cmd_data, msg->cmd_data_length);
      }
      else
      {
	valid_cmd = 0;
      }
      break;
    }
    ipcif_deleteMsg(msg);
    return cmd_no;
  }
  return 0;
}

#endif /* WITH_IPCIF */
