/* $Id: scr_ipcif.c,v 1.1.1.1 2004/05/09 03:04:07 tkudou Exp $ */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif /* HAVE_CONFIG_H */

#include <string.h>
#include <stdlib.h>

#include "scr.h"
#include "scr_real.h"

#include "ipcif.h"
#include "ipcifcmd.h"

static IPCIF_Shm* shm = 0;

static IPCIF_Bool remove_resource_p = IPCIF_True;

void
scrIpcifSetDontRemoveResourceP()
{
  remove_resource_p = IPCIF_False;
}

static int
open_IpcifScreen (void)
{
  ipcif_initialize();
  shm = ipcif_getShm();
  return 1;
}

static void
close_IpcifScreen (void)
{
  ipcif_finalize(remove_resource_p);
}

static void
describe_IpcifScreen (ScreenDescription *description)
{
  ipcif_lockSemaphore();
  description->cols = shm->dim_x;	/* scrdim x */
  description->rows = shm->dim_y;   	/* scrdim y */
  description->posx = shm->cursor_x;   /* csrpos x */
  description->posy = shm->cursor_y;   /* csrpos y */
  description->no = 1;
  ipcif_unlockSemaphore();
}

static unsigned char *
read_IpcifScreen(ScreenBox box, unsigned char* buffer, ScreenMode mode)
{
  ScreenDescription description;
  ipcif_lockSemaphore();
  description.cols = shm->dim_x;	/* scrdim x */
  description.rows = shm->dim_y;   	/* scrdim y */
  description.posx = shm->cursor_x;   /* csrpos x */
  description.posy = shm->cursor_y;   /* csrpos y */
  description.no = 1;
  if (!validateScreenBox(&box, description.cols, description.rows))
  {
    buffer = 0;
  }
  else
  {
    int row;
    int row_offset, col_offset;
    row_offset = box.top;
    col_offset = box.left;
    for (row = 0; row < box.height; row++)
    {
      memcpy(buffer + (row * box.width), &shm->img[row_offset + row][col_offset], box.width);
    }
  }
  ipcif_unlockSemaphore();
  return buffer;
}

void
initializeLiveScreen (MainScreen *main)
{
  initializeRealScreen(main);
  main->base.describe = describe_IpcifScreen;
  main->base.read = read_IpcifScreen;
  main->open = open_IpcifScreen;
  main->close = close_IpcifScreen;
}

