/*
 * test6
 *
 * This file has some test codes for the semaphore and the shared memory.
 *
 * $Id: dumpshm.c,v 1.1.1.1 2004/05/09 03:04:09 tkudou Exp $
 */

#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>

#define WITH_IPCIF
#include "ipcif.h"

IPCIF_Shm* shm;

void
dump()
{
  int x, y;
  int dim_y, dim_x;
  
  ipcif_lockSemaphore();
  printf("dim_x: %d\n", shm->dim_x);
  printf("dim_y: %d\n", shm->dim_y);
  printf("cursor_x: %d\n", shm->cursor_x);
  printf("cursor_y: %d\n", shm->cursor_y);

  dim_x = shm->dim_x;
  if (dim_x > IPCIF_SHM_DIM_X_MAX)
  {
    dim_x = IPCIF_SHM_DIM_X_MAX;
  }
  dim_y = shm->dim_y;
  if (dim_y > IPCIF_SHM_DIM_Y_MAX)
  {
    dim_y = IPCIF_SHM_DIM_Y_MAX;
  }
  
  for (y = 0; y < dim_y; y++)
  {
    printf("%03d: ", y);
    for (x = 0; x < dim_x; x++)
    {
      printf("%c", shm->img[y][x]);
    }
    printf("\n");
  }
  fflush(stdout);
  
  ipcif_unlockSemaphore();
}

int
main()
{
  char buf[100];
  ipcif_initialize();
  shm = ipcif_getShm();

  for (;;)
  {
    printf(">");
    fgets(buf, sizeof(buf), stdin);
    if (buf[0] == '.')
    {
      break;
    }
    dump();
  }
  
  ipcif_finalize(IPCIF_False);
  return 0;
}

