/* $Id: ipcifcmd.c,v 1.1.1.1 2004/05/09 03:04:09 tkudou Exp $ */

#include <string.h>

#define WITH_IPCIF
#include "ipcifcmd.h"

IPCIF_Bool
ipcif_sendCmdWithData(IPCIF_Sender sender, IPCIF_Cmd cmd, int data_length, char* data)
{
  IPCIF_Bool ret = IPCIF_Failure;
  IPCIF_Msg* msg;
  msg = ipcif_initMsg(cmd, sender, data_length + 1, data);
  if (msg)
  {
    msg->cmd_data[data_length] = '\0';
    ret = ipcif_sendMsg(msg);
  }
  return ret;
}

IPCIF_Bool
ipcif_sendCmd(IPCIF_Sender sender, IPCIF_Cmd cmd)
{
  return ipcif_sendCmdWithData(sender, cmd, 0, 0);
}

IPCIF_Bool
ipcif_sendCmdVoice(IPCIF_Sender sender, char* str, int length)
{
  return ipcif_sendCmdWithData(sender, IPCIF_CMD_VOICE, length, str);
}

IPCIF_Bool
ipcif_sendCmdDetailVoice(IPCIF_Sender sender, char* str, int length)
{
  return ipcif_sendCmdWithData(sender, IPCIF_CMD_DETAIL_VOICE, length, str);
}

IPCIF_Bool
ipcif_sendCmdStopVoice(IPCIF_Sender sender)
{
  IPCIF_Msg* msg;
  while (msg = ipcif_readMsg())
  {
    ipcif_deleteMsg(msg);
  }
  return ipcif_sendCmdWithData(sender, IPCIF_CMD_MUTE, 0, 0);
}
