/*
 * test6
 *
 * This file has some test codes for the semaphore and the shared memory.
 *
 * $Id: test6.c,v 1.1.1.1 2004/05/09 03:04:09 tkudou Exp $
 */

#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>

#define WITH_IPCIF
#include "ipcif.h"

#define TEST_HOLD_IMP
#include "test.h"

int try_num = 100;

void
test1()
{
  IPCIF_Bool ret;
  IPCIF_Shm* shm;
  int n;
  struct timespec t;
  t.tv_sec = 0;
  t.tv_nsec = 10000; /* 10 mSec */

  shm = ipcif_getShm();
  SHOULD_NOT_BE_NULL(shm);

  printf(".");
  fflush(stdout);
  ret = ipcif_hasLockP();
  SHOULD_BE_FALSE(ret);

  for (n = 0; n < try_num; n++)
  {
    ipcif_lockSemaphore();
    ret = ipcif_hasLockP();
    SHOULD_BE_TRUE(ret);

    shm->cursor_x ++;

    printf(".");
    fflush(stdout);
    ipcif_unlockSemaphore();
    ret = ipcif_hasLockP();
    SHOULD_BE_FALSE(ret);

    nanosleep(&t, NULL);
  }

  t.tv_sec = 3; /* 1 Sec */
  t.tv_nsec = 0;
  nanosleep(&t, NULL);

  SHOULD_BE_TRUE(shm->cursor_x == 0);

  printf("\n");
  fflush(stdout);
}

void
test2()
{
  IPCIF_Bool ret;
  IPCIF_Shm* shm;
  int n;
  struct timespec t;

#if 0
  t.tv_sec = 0;
  t.tv_nsec = 100000; /* 100 mSec */
  nanosleep(&t, NULL);
#endif

  t.tv_sec = 0;
  t.tv_nsec = 7000; /* 7 mSec */

  shm = ipcif_getShm();
  SHOULD_NOT_BE_NULL(shm);

  printf("*");
  fflush(stdout);
  ret = ipcif_hasLockP();
  SHOULD_BE_FALSE(ret);

  for (n = 0; n < try_num; n++)
  {
    ipcif_lockSemaphore();
    ret = ipcif_hasLockP();
    SHOULD_BE_TRUE(ret);

    shm->cursor_x --;

    printf("*");
    fflush(stdout);
    ipcif_unlockSemaphore();
    ret = ipcif_hasLockP();
    SHOULD_BE_FALSE(ret);

    nanosleep(&t, NULL);
  }
  printf("\n");
  fflush(stdout);
}

int
main()
{
  pid_t pid;

  test_initialize();
  /* ipcif_initialize(); */
  pid = fork();
  if (pid == -1)
  {
    SHOULD_BE_TRUE(0);
    test_show_result();
    return test_get_assert_number();
  }
  
  if (pid)
  {
    ipcif_initialize();
    test1();
    ipcif_finalize(IPCIF_False);
  }
  else
  {
    ipcif_initialize();
    test2();
    ipcif_finalize(IPCIF_True);
  }

  test_show_result();
  return test_get_assert_number();
}

