#include "ksyousai.h"

#include <stdio.h>

#ifdef INTERNAL_DATA

YomiItem yomi_item[] ={
#include "ksyousai.inc"
{ 0,0,0 }
};

KanjiSyousaiYomi::KanjiSyousaiYomi()
{
  syousai_item = sizeof(yomi_item) / sizeof(YomiItem);
}

KanjiSyousaiYomi::~KanjiSyousaiYomi()
{
}

#else /* INTERNAL_DATA */

KanjiSyousaiYomi::KanjiSyousaiYomi()
{
  syousai_item = 0;
  char  buff[1024];
  FILE * dic = fopen("emacspeak-kanji.csv","r");  // euc file
  int count = 0;
  while (fgets(buff, 1000, dic) != NULL)
  {
    if (buff[0])
    {
      count++;
    }
  }
  rewind(dic);
  syousai_item = count;
  yomi_item = new YomiItem[count+1];
  YomiItem * p = yomi_item;
  while (fgets(buff, 1000, dic) != NULL)
  {
    char * i1 = buff;
    char * i2 = buff;
    while (*i2)
    {
      if (*i2 == ',')   // 1,  -> i2
      {
	*i2 = '\0';
	i2++;
	break;
      }
      i2++;
    }
    char *i3 = i2;
    while (*i3)
    {
      if (*i3 == ',')  // 1,2, -> i3
      {
	*i3 = '\0';
	i3++;
	break;
      }
      i3++;
    }
    char *i4 = i3;
    while (*i4)
    {
      if (*i4 == ',')  // 1,2,3, --> i4
      {
	*i4 = '\0';
	i4++;
	break;
      }
      i4++;
    }
    char *l = i4;
    while (*l)
    {
      if (((unsigned char ) *l) <= 0x1f)
      {
	*l = '\0';
	break;
      }
      l++;
    }
    
    EucString * kanji = new EucString(i1);
    EucString * yomi_short = new EucString(i2);
    EucString * yomi_long1 = new EucString(i3);
    EucString * yomi_long2 = new EucString(i4);
    p->kanji = kanji;
    p->yomi_short = yomi_short;
    p->yomi_long1 = yomi_long1;
    p->yomi_long2 = yomi_long2;
    p++;
    printf("{ \"%s\",\"%s\",\"%s\" }, \n", i1, i2, i3);
  }
  fclose(dic);
}

KanjiSyousaiYomi::~KanjiSyousaiYomi()
{
  YomiItem * p = yomi_item;
  int i;
  
  for (i = 0; i< syousai_item; i++)
  {
    delete p->yomi_short;
    delete p->yomi_long1;
    delete p->yomi_long2;
    p++;
  }
  delete yomi_item;
}
#endif /* INTERNAL_DATA */



#ifdef INTERNAL_DATA
EucString * KanjiSyousaiYomi::yomiconv(const EucString * src)
{
  int low = 0;
  int hi = syousai_item -1;
  int mid;
  EucString t;
  
  while (low <= hi)
  {
    mid = (low + hi) / 2;
    t = yomi_item[mid].kanji;
    
    if (*src == t)
    {
      outbuf = yomi_item[mid].yomi_long1;
      return &outbuf;
    }
    else if (*src < t)
    {
      hi = mid -1;
    }
    else
    {
      low = mid+1;
    }
  }
  return 0;
}
#else
EucString * KanjiSyousaiYomi::yomiconv(const EucString * src)
{
  int low = 0;
  int hi = syousai_item -1;
  int mid;
  
  while (low <= hi)
  {
    mid = (low + hi) / 2;
    EucString * t = yomi_item[mid].kanji;
    
    if (*src == *t)
    {
      return yomi_item[mid].yomi_long1;
    }
    else if (*src < *t)
    {
      hi = mid -1;
    }
    else
    {
      low = mid+1;
    }
  }
  return 0;
}
#endif


static	char *setumei(char c)
{
  switch(c){
   case '!': return(" 󤿤 ");
   case '\"':return(" ơ ");
   case '#': return(" 㡼 ");
   case '$': return(" ɤ ");
   case '%': return(" ѡ ");
   case '&': return(" Ф ");
   case '\'':return(" ݤȤդ ");
   case '(': return(" äҤ餭 ");
   case ')': return(" äȤ ");
   case '*': return(" ꤹ ");
   case '+': return(" פ餹 ");
   case ',': return("  ");
   case '-': return(" Ϥդ ");
   case '.': return(" Ԥꤪ ");
   case '/': return(" ä ");
   case ':': return("  ");
   case ';': return(" ߤ ");
   case '<': return(" 礦ʤ ");
   case '=': return("  ");
   case '>': return(" ʤ ");
   case '?': return("  ");
   case '@': return(" ä ");
   case '[': return(" äҤ餭 ");
   case '\\':return(" ޡ ");
   case ']': return(" äȤ ");
   case '^': return(" ٤硼 ");
   case '_': return("  ");
   case '`': return(" 󤰤顼 ");
   case '{': return(" 塼äҤ餭 ");
   case '|': return(" Ƥ ");
   case '}': return(" 塼äȤ ");
   case '~': return(" Ǥ ");
   case 0xa1: return(" ޤ ");/* '' */
   case 0xa2: return(" Ҥ餭 ");/* '' */
   case 0xa3: return(" Ȥ ");/* '' */
   case 0xa4: return(" Ƥ ");/* '' */
   case 0xa5: return(" ʤƤ ");/* '' */
   case 0xb0: return(" 硼 ");
   case 0xde: return(" Ƥ ");/* '' */
   case 0xdf: return(" ϤƤ ");/* '' */
  }
  return NULL ;
}

static	char *eng_setumei(char c)
{
  switch(c){
   case '!': return(" exclamation point ");
   case '\"': return(" quote ");
   case '#': return(" number ");
   case '$': return(" dollar ");
   case '%': return(" percent ");
   case '&': return(" ampersand ");
   case '\'': return(" apostrophe ");
   case '(': return(" open parenthesis ");
   case ')': return(" close parenthesis ");
   case '*': return(" asterisk ");
   case '+': return(" plus ");
   case ',': return(" comma ");
   case '-': return(" minus ");
   case '.': return(" period ");
   case '/': return(" slush ");
   case ':': return(" colon ");
   case ';': return(" semicolon ");
   case '<': return(" less than ");
   case '=': return(" equals ");
   case '>': return(" greater than ");
   case '?': return(" question mark ");
   case '@': return(" at sign ");
   case '[': return(" open bracket ");
   case '\\': return(" backslash ");
   case ']': return(" close bracket ");
   case '^': return(" caret ");
   case '_': return(" underscore ");
   case '`': return(" backquote ");
   case '{': return(" open brace ");
   case '|': return(" bar ");
   case '}': return(" close brace ");
   case '~': return(" tilde ");
  }
  return NULL ;
}



#if 0
void test(KanjiSyousaiYomi & ksyo, char * str)
{
  printf("%s:", str);
  EucString s(str);
  printf("%s\n", ksyo.yomiconv(&s)->c_str());
}


main()
{
  KanjiSyousaiYomi ksyo;
  
  test(ksyo,"");
  test(ksyo,"");
  test(ksyo,"");
  test(ksyo,"");
  test(ksyo,"");
  test(ksyo,"");
}
#endif
