#include <stdio.h>

#include "syousai.h"

struct KTableItem 
{
  char * code;
  CharType char_type;
};

struct HTableItem 
{
  char * code;
  CharType char_type;
};

KTableItem ktable_item[] =
{
  {
    "¤äĤŤƤǤȤɤʤˤ̤ͤΤϤФ"
    "ҤӤԤդ֤פؤ٤ڤۤܤݤޤߤ",
    CharType_ZEN_HIRA
  },
  {
    "¥åĥťƥǥȥɥʥ˥̥ͥΥϥХ"
    "ҥӥԥե֥ץإ٥ڥۥܥݥޥߥ",
    CharType_ZEN_KANA
  },
  {
    "£ãģţƣǣȣɣʣˣ̣ͣΣϣУѣңӣԣգ֣ףأ٣",
    CharType_ZEN_UPCASE_ALPHA
  },
  {
    "",
    CharType_ZEN_DOWNCASE_ALPHA,
  },
  {
    "", 
    CharType_ZEN_NUM,
  },
  {
    "¡áġšơǡȡɡʡˡ̡͡ΡϡСѡҡӡԡա֡סء١ڡۡܡݡޡߡʢˢ̢͢΢ϢТܢݢޢߢ"
    ""
    "¦æĦŦƦǦȦɦʦ˦̦ͦΦϦЦѦҦӦԦզ֦צ"
    ""
    "ѧҧӧԧէ֧קا٧ڧۧܧݧާߧ"
    "|",
    CharType_ZEN_SYM
  },
  {
    "ÎĎŎƎǎȎɎʎˎ͎̎ΎώЎюҎӎԎՎ֎׎؎َڎێ܎ݎގ",
    CharType_ANK_KANA
  },
  {
    0, CharType_UNDEF
  }
};

HTableItem htable_item[] = 
{
  {
    "ABCDEFGHIJKLMNOPQRSTUVWXYZ", 
    CharType_ANK_UPCASE_ALPHA
  },
  {
    "abcdefghijklmnopqrstuvwxyz",
    CharType_ANK_DOWNCASE_ALPHA
  },	
  {	
    "0123456789",
    CharType_ANK_NUM
  },
  {
    0, CharType_UNDEF
  }
};


  
bool isEucKanji(int h, int l)
{
  return (h >= 0xb0 && h <= 0xf4 && l >= 0xa1 && l <= 0xfe);
}

CharType getktype(int h, int l)
{
  KTableItem * p = ktable_item;
  while (p->code)
  {
    unsigned char * cp = (unsigned char *) (p->code);
    while (*cp)
    {
      if (*cp == h && (*(cp+1) == l))
      {	
	return p->char_type;
      }
      cp += 2;
    }
    p++;
  }
  return CharType_UNDEF;
}

CharType gettype(int h, int l)
{
  CharType t = getktype(h, l);
  if (t != CharType_UNDEF)
  {
    return t;
  }
  else if (isEucKanji(h,l))
  {
    return CharType_KANJI;
  }
  return t;
}


main()
{
  KTableItem *kp = ktable_item;
  int i;
  
  for (i = 0x8000; i<=0xffff; i++)
  {
    int h = i >> 8;
    int l = i & 0xff;
  
    CharType t = gettype(h,l);
#if 0
    if (t)
      printf("%c%c=", h, l);
#endif
    printf("%d,", t);
    if ((i & 0x0f) == 0x0f)
    {
      printf("/* %04x */\n", i & 0xfff0);
    }
  }
}
